/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sim.data;

import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;
import java.util.HashMap;
import javax.imageio.ImageIO;
import sim.data.finals.Anlage;
import sim.data.finals.BadLampe;
import sim.data.finals.Computer;
import sim.data.finals.Fernseher;
import sim.data.finals.Geschirr;
import sim.data.finals.Kaffee;
import sim.data.finals.Lavalampe;
import sim.data.finals.Mikrowelle;
import sim.data.finals.Mixer;
import sim.data.finals.Ofen;
import sim.data.finals.SchlafLampe;
import sim.data.finals.SchlafSchalter;
import sim.data.finals.Telefon;
import sim.data.finals.Wanne;
import sim.data.finals.Waschmaschine;
import sim.data.finals.BadSchalter;
import sim.data.finals.FernseherGame;
import sim.data.finals.FernseherNoGame;
import sim.data.finals.GameLampe;
import sim.data.finals.GameSchalter;
import sim.data.finals.KuecheLampe;
import sim.data.finals.KuecheSchalter;
import sim.data.finals.PlayStation;
import sim.data.finals.WaschLampe;
import sim.data.finals.WaschSchalter;
import sim.data.finals.WohnLampe;
import sim.data.finals.WohnSchalter;

/**
 *
 * @author Dromliuss
 */
public abstract class Gerät extends UnicastRemoteObject implements GerätRemote {

    public static final HashMap<Class<? extends Gerät>, BufferedImage> onImg;
    public static final HashMap<Class<? extends Gerät>, BufferedImage> onSmartImg;

    static {
        onImg = new HashMap<>();
        onSmartImg = new HashMap<>();
        try {
            onImg.put(Fernseher.class, ImageIO.read(new File("./cache/LivR_tv_386x416.png").toURI().toURL()));
            onImg.put(Computer.class, ImageIO.read(new File("./cache/bedR_com_82x189.png").toURI().toURL()));
            onImg.put(Lavalampe.class, ImageIO.read(new File("./cache/BedR_lamp_228x198.png").toURI().toURL()));
            onImg.put(Wanne.class, ImageIO.read(new File("./cache/bad_tub_351x272.png").toURI().toURL()));
            onImg.put(Geschirr.class, ImageIO.read(new File("./cache/idk_dish_856x440.png").toURI().toURL()));
            onImg.put(Telefon.class, ImageIO.read(new File("./cache/livR_phone_574x448.png").toURI().toURL()));
            onImg.put(Anlage.class, ImageIO.read(new File("./cache/playR_hifi_448x243.png").toURI().toURL()));
            onImg.put(Mixer.class, ImageIO.read(new File("./cache/kitchen_mix_150x409.png").toURI().toURL()));
            onImg.put(Kaffee.class, ImageIO.read(new File("./cache/kitchen_coffee_156x415.png").toURI().toURL()));
            onImg.put(Mikrowelle.class, ImageIO.read(new File("./cache/kitchen_micro_238x413.png").toURI().toURL()));
            onImg.put(Ofen.class, ImageIO.read(new File("./cache/kitchen_cook_69x442.png").toURI().toURL()));
            onImg.put(Waschmaschine.class, ImageIO.read(new File("./cache/idk_wash_752x392.png").toURI().toURL()));
            onImg.put(SchlafSchalter.class, ImageIO.read(new File("./cache/bedR_switch 49 226.png").toURI().toURL()));
            onImg.put(SchlafLampe.class, ImageIO.read(new File("./cache/bedR_light_171x152.png").toURI().toURL()));
            onImg.put(BadLampe.class, ImageIO.read(new File("./cache/bad_light_320x130.png").toURI().toURL()));
            onImg.put(BadSchalter.class, ImageIO.read(new File("./cache/bad_switch_178x170.png").toURI().toURL()));
            onImg.put(GameLampe.class, ImageIO.read(new File("./cache/playR_light2_628x130.png").toURI().toURL()));
            onImg.put(GameSchalter.class, ImageIO.read(new File("./cache/playR_switch_663x215.png").toURI().toURL()));
            onImg.put(KuecheLampe.class, ImageIO.read(new File("./cache/kitchen_light2_154x365.png").toURI().toURL()));
            onImg.put(KuecheSchalter.class, ImageIO.read(new File("./cache/kitchen_light_53x413.png").toURI().toURL()));
            onImg.put(WohnLampe.class, ImageIO.read(new File("./cache/livR_light2_688x389.png").toURI().toURL()));
            onImg.put(WohnSchalter.class, ImageIO.read(new File("./cache/livR_light_326x447.png").toURI().toURL()));
            onImg.put(WaschLampe.class, ImageIO.read(new File("./cache/idk_light2_747x365.png").toURI().toURL()));
            onImg.put(WaschSchalter.class, ImageIO.read(new File("./cache/idk_light_902x416.png").toURI().toURL()));
            onImg.put(FernseherNoGame.class, ImageIO.read(new File("./cache/gameTv.png").toURI().toURL()));
            onImg.put(PlayStation.class, ImageIO.read(new File("./cache/PlayStation.png").toURI().toURL()));
            onImg.put(FernseherGame.class, ImageIO.read(new File("./cache/gameTv1.png").toURI().toURL()));

            onSmartImg.put(Waschmaschine.class, ImageIO.read(new File("./cache/idk_wash_752x392Smart.png").toURI().toURL()));
            onSmartImg.put(Geschirr.class, ImageIO.read(new File("./cache/idk_dish_856x440Smart.png").toURI().toURL()));
        } catch (IOException ioe) {
            System.out.println("cant loadOnGeräte");
        }
    }
//
    private final String NAME;
    private final int STROMVERBRAUCH;
    private final int DELAY;
    private final boolean isSmart;
    //
    private boolean isOn;

    @Override
    public boolean isSchalter() throws RemoteException {
        return false;
    }

    public Gerät(String NAME, int STROMVERBRAUCH, int DELAY, boolean isSmart) throws RemoteException {
        this.NAME = NAME;
        this.STROMVERBRAUCH = STROMVERBRAUCH;
        this.DELAY = DELAY * 2500;
        this.isSmart = isSmart;
    }

    public Gerät(String NAME, int STROMVERBRAUCH, boolean isSmart) throws RemoteException {
        this.NAME = NAME;
        this.STROMVERBRAUCH = STROMVERBRAUCH;
        this.DELAY = -1;
        this.isSmart = isSmart;
    }
    private Haus home;

    public void setHome(Haus home) {
        this.home = home;
    }

    public Haus getHome() {
        return home;
    }

    @Override
    public String getNAME() {
        return NAME;
    }

    @Override
    public int getSTROMVERBRAUCH() {
        return STROMVERBRAUCH;
    }

    @Override
    public int getDELAY() {
        return DELAY;
    }

    @Override
    public boolean isOn() {
        return isOn;
    }

    private long timeStart = 0;

    private boolean isSmartWait;
    private boolean smartNotified;

    @Override
    public boolean isSmartWait() {
        return isSmartWait;
    }

    @Override
    public boolean toggle() {
        if (getHome().isIsSmart() && isSmart) {
            if (!isOn && !smartNotified) {
                isSmartWait = !isSmartWait;
                return false;
            }
            if (smartNotified && isSmartWait) {
                isOn = true;
                timeStart = System.currentTimeMillis();
                isSmartWait = false;
                if (!(this instanceof Schalter)) {
                    PowerPlant.get().smartNotify(this);
                }
                return true;
            }
            if (isOn && smartNotified && System.currentTimeMillis() - timeStart >= DELAY) {
                isOn = false;
            }
            return false;
        }

        if (!isOn) {
            timeStart = System.currentTimeMillis();
        } else {
            if (isOn && System.currentTimeMillis() - timeStart < DELAY) {
                return false;
            }
        }
        isOn = !isOn;
        if (!(this instanceof Schalter)) {
            PowerPlant.get().smartNotify(this);
        }
        return true;
    }

    @Override
    public int getTimeElapsed() throws RemoteException {
        return (int) (System.currentTimeMillis() - timeStart) > 0 ? (int) (System.currentTimeMillis() - timeStart) : -1;
    }

    @Override
    public void live() throws RemoteException {
        if (DELAY == -1 || !isOn) {
            return;
        }
        if (System.currentTimeMillis() - timeStart >= DELAY) {
            smartNotified = true;
            toggle();
            smartNotified = false;
        }
    }

    @Override
    public Class<? extends Gerät> getGeräteClass() throws RemoteException {
        return getClass();
    }

    void notifySmart() {
        if (!getHome().isIsSmart() || !isSmart) {
            return;
        }
        smartNotified = true;
        toggle();
        smartNotified = false;
    }

}
