/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package sim.graphics;

import help.math.IntPosition;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.rmi.RemoteException;
import java.util.ArrayList;
import java.util.EnumMap;
import java.util.HashMap;
import java.util.List;
import javax.imageio.ImageIO;
import sim.data.Gerät;
import sim.data.GerätRemote;
import sim.data.HausRemote;
import sim.data.RoomRemote;
import sim.data.WorldRemote;

/**
 *
 * @author Dromlius
 */
public class HausPanel extends DoubleBufferedPanel implements ScreenNode {

    private final HausPanel selfReference = this;
    //
    //   private final int RESOLUTION;
    //
    //
    private BufferedImage[] smartMeter;
    private BufferedImage smartWait;
    private BufferedImage sky;
    private Thread shutDowner;

    //
    @SuppressWarnings({"CallToThreadStartDuringObjectConstruction", "LeakingThisInConstructor"})
    public HausPanel(int width, int height, final HausRemote hausRemote, final WorldRemote worldRemote) {
        super(width, height);
        try {
            smartWait = ImageIO.read(new File("./cache/smartWait.png").toURI().toURL());
            smartMeter = new BufferedImage[]{ImageIO.read(new File("./cache/smeter01.png").toURI().toURL()), ImageIO.read(new File("./cache/smeter02.png").toURI().toURL())};
        } catch (IOException ex) {
            System.out.println("Cant load SmartWaitSign");
        }
        shutDowner = new Thread(new Runnable() {

            @Override
            public void run() {
                while (drawing) {
                    try {
                        for (int i = 0; i < hausRemote.getHausGerätAnzahl(); i++) {
                            hausRemote.getHausGerät(i).live();
                        }
                    } catch (RemoteException re) {
                        re.printStackTrace();
                    }
                }
            }
        }
        );

        actionAreas = new EnumMap<>(Trigger.class);
        //
        //    setBackground(Color.BLUE);
//        RESOLUTION = Integer.parseInt(System.getProperty("Resolution"));
        //-----------
        children = new ArrayList<>();
        //
        ScreenArea mainScreen = new ScreenArea("MainScreen", 0, 0, 1000, 700, this) {
            private BufferedImage house;
            private BufferedImage houseSmart;

            @Override
            public DrawCondition drawCondition(DrawCondition parentalDrawCondition) {
                return parentalDrawCondition;
            }

            @Override
            public void internalDraw() {
                if (house == null) {
                    try {
                        house = ImageIO.read(new File("./cache/1off.png").toURI().toURL());
                        houseSmart = ImageIO.read(new File("./cache/1offSmart.png").toURI().toURL());
                        sky = ImageIO.read(new File("./cache/SkyBox.png").toURI().toURL());
                        for (int i = 0; i < hausRemote.getHausGerätAnzahl(); i++) {
                            final GerätRemote hausGerät = hausRemote.getHausGerät(i);
                            //       System.out.println("adding: "+hausGerät.getNAME()+" "+hausGerät.getHitBox());
                            if (hausGerät.getHitBox() != null) {
                                addActionArea(Trigger.MouseClick, this, new ScreenFixActionArea(hausGerät.getHitBox(), new Runnable() {
                                    @Override
                                    public void run() {
                                        try {
                                            hausGerät.toggle();
                                        } catch (RemoteException re) {
                                            System.out.println("owwww");
                                        }
                                    }
                                }));
                            }
                        }
                    } catch (IOException ioe) {
                        System.out.println("cant load houseImg");
                    }
                }
                Graphics mainGraphics = getScreenAreaGraphics();
                mainGraphics.setColor(Color.BLACK);
                mainGraphics.fillRect(0, 0, 9999, 9999);
                try {
                    mainGraphics.drawImage(sky, (getScreenAreaWidth() / 2) - (int) (worldRemote.getTime() * sky.getWidth() / 24), 0, null);
                    mainGraphics.drawImage(sky, (getScreenAreaWidth() / 2) - (int) (worldRemote.getTime() * sky.getWidth() / 24) - sky.getWidth(), 0, null);
                } catch (RemoteException re) {
                    System.out.println("Nobo");
                    re.printStackTrace();
                }
                try {
                    if (hausRemote.isIsSmart()) {
                        mainGraphics.drawImage(houseSmart, 0, 0, null);
                    } else {
                        mainGraphics.drawImage(house, 0, 0, null);
                    }

                    for (int i = 0; i < hausRemote.getHausGerätAnzahl(); i++) {
                        if ((!hausRemote.isBlackOut() || hausRemote.getHausGerät(i).isSchalter())) {
                            GerätRemote hausGerät = hausRemote.getHausGerät(i);
                            IntPosition pos = hausGerät.getDrawPosition();
                            if (hausGerät.isSmartWait()) {
                                mainGraphics.drawImage(smartWait, pos.getX(), pos.getY() + smartWait.getHeight(), null);
                            }
                            if (hausGerät.isOn()) {
                                //   mainGraphics.setColor(Color.BLACK);
                                //    mainGraphics.fillRect(rect.x, rect.y, rect.width, rect.height);
                                if (hausRemote.isIsSmart() && Gerät.onSmartImg.get(hausGerät.getGeräteClass()) != null) {
                                    mainGraphics.drawImage(Gerät.onSmartImg.get(hausGerät.getGeräteClass()), pos.getX(), pos.getY(), null);
                                } else {
                                    mainGraphics.drawImage(Gerät.onImg.get(hausGerät.getGeräteClass()), pos.getX(), pos.getY(), null);
                                }
                                if (hausGerät.getTimeElapsed() < hausGerät.getDELAY()) {
                                    mainGraphics.setColor(Color.CYAN);
                                    mainGraphics.fillArc(hausGerät.getHitBox().x + hausGerät.getHitBox().width / 2 - 10, hausGerät.getHitBox().y + hausGerät.getHitBox().height / 2 - 10, 20, 20, 90, -360 * hausGerät.getTimeElapsed() / hausGerät.getDELAY());
                                }
                            }
                        }
                    }
                    if (hausRemote.isIsSmart()) {
                        // mainGraphics.setColor(Color.GREEN);
                        mainGraphics.drawImage(smartMeter[(int) (System.currentTimeMillis() / 1000) % 2], 0, 0, null);
                    }
                    int darkness = (int) ((12 - Math.abs(worldRemote.getTime() - 12)) * 6d);
                    mainGraphics.setColor(new Color(darkness, darkness, darkness, 128));
                    for (int i = 0; i < hausRemote.getRoomAnzahl(); i++) {
                        RoomRemote room = hausRemote.getRoom(i);
                        if (room.isDark() || hausRemote.isBlackOut()) {

                            mainGraphics.fillRect(room.getRect().x, room.getRect().y, room.getRect().width, room.getRect().height);
                        }
                    }
                } catch (RemoteException re) {
                    System.out.println("owwww");
                }
            }
        };
        /*      ScreenArea sidebar = new ScreenArea("Sidebar", new RightBelowOrientation(mainScreen), 0, new RightBelowOrientation(mainScreen), mainScreen.getScreenAreaHeight(), this) {
         @Override
         public DrawCondition drawCondition(DrawCondition parentalDrawCondition) {
         return parentalDrawCondition;
         }

         @Override
         public void internalDraw() {
         // System.out.println(tabBg == null);
         /*    for (int x = 0; x <= getScreenAreaWidth() / tabBg.getWidth(); x++) {
         for (int y = 0; y <= getScreenAreaHeight() / tabBg.getHeight(); y++) {
         getScreenAreaGraphics().drawImage(tabBg, x * tabBg.getWidth(), y * tabBg.getHeight(), null);
         }
         }
         }
         getScreenAreaGraphics().setColor(Color.BLUE);
         getScreenAreaGraphics().fillRect(0, 0, 9999, 9999);
         }
         };
         ScreenArea subBar = new ScreenArea("SubBar", 0, new RightBelowOrientation(mainScreen), 1f, new RightBelowOrientation(mainScreen), this) {
         @Override
         public DrawCondition drawCondition(DrawCondition parentalDrawCondition) {
         return parentalDrawCondition;
         }

         @Override
         public void internalDraw() {
         Graphics drawHelpBarGraphics = getScreenAreaGraphics();
         //bg
         drawHelpBarGraphics.setColor(Color.GREEN);
         drawHelpBarGraphics.fillRect(0, 0, 9999, 9999);
         }
         };
         //

         */ setFocusable(
                true);
        MouseAdapter mouseAdapter = new MouseAdapter() {
            @Override
            public void mouseMoved(MouseEvent e) {
                tooltipping = false;
                ScreenNode insideNode = insideNode(e.getPoint());
                try {
                    for (ScreenActionArea actionArea : actionAreas.get(Trigger.MouseHover).get(insideNode)) {
                        if (actionArea.getArea().contains(e.getPoint())) {
                            actionArea.getAction().run();
                        }
                    }
                } catch (NullPointerException npe) {
                }
                if (!tooltipping) {
                    setTooltip(null);
                }
            }

            @Override
            public void mousePressed(MouseEvent e) {
                ScreenNode insideNode = insideNode(e.getPoint());
                //   System.out.println(e.getPoint());
                try {
                    for (ScreenActionArea actionArea : actionAreas.get(Trigger.MouseClick).get(insideNode)) {
                        //          System.out.println(actionArea.getArea());
                        if (actionArea.getArea().contains(e.getPoint())) {
                            actionArea.getAction().run();
                        }
                    }
                } catch (NullPointerException npe) {
                }
            }

            private ScreenNode insideNode(Point p) {

                ScreenNode recursion = selfReference;
                while (!recursion.getChildren().isEmpty()) {
                    boolean newChild = false;
                    for (int indx = 0; indx < recursion.getChildren().size() && !newChild; indx++) {
                        if (recursion.getChildren().get(indx).internalDrawCondition() == DrawCondition.HIDE) {
                            continue;
                        }
                        if (recursion.getChildren().get(indx).getAbsoluteArea().contains(p)) {
                            recursion = recursion.getChildren().get(indx);
                            newChild = true;
                        }
                    }
                    if (!newChild) {
                        return recursion;
                    }
                }
                return recursion;
            }

        };

        addMouseMotionListener(mouseAdapter);

        addMouseListener(mouseAdapter);
    }

//
    private Tooltip tooltip;
    private boolean tooltipping;
    private long tooltipTimer;

    private void setTooltip(Tooltip tooltip) {
        this.tooltip = tooltip;
        tooltipping = (tooltip != null);
    }

    @Override
    @SuppressWarnings("CallToThreadDumpStack")
    public void internalDraw() {
        for (ScreenNode child : getChildren()) {
            child.draw();
        }
        //   drawTooltip();
        if (tooltip == null) {
            tooltipping = false;
        }
        //FPS
        graphics.setColor(Color.WHITE);
    }

    @Override
    public int getScreenAreaWidth() {
        return getWidth();
    }

    @Override
    public int getScreenAreaHeight() {
        return getHeight();
    }
    public EnumMap<Trigger, HashMap<ScreenNode, ArrayList<ScreenActionArea>>> actionAreas;

    @Override
    public Rectangle getAbsoluteArea() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public int getAbsoulteX() {
        return 0;
    }

    @Override
    public int getAbsoulteY() {
        return 0;
    }

    private List<ScreenNode> children;

    @Override
    public DrawCondition internalDrawCondition() {
        return DrawCondition.VISIBLE;
    }

    @Override
    public void drawImage(IntPosition position, BufferedImage bufferedImage) {
        graphics.drawImage(bufferedImage, position.getX(), position.getY(), null);
    }

    @Override
    public List<ScreenNode> getChildren() {
        return children;
    }

    @Override
    public void addChild(ScreenNode child) {
        children.add(child);
    }

    @Override
    public void addActionArea(sim.graphics.Trigger trigger, sim.graphics.ScreenNode owner, sim.graphics.ScreenActionArea actionArea) {
        if (actionAreas.get(trigger) == null) {
            actionAreas.put(trigger, new HashMap<ScreenNode, ArrayList<ScreenActionArea>>());
        }
        if (actionAreas.get(trigger).get(owner) == null) {
            actionAreas.get(trigger).put(owner, new ArrayList<ScreenActionArea>());
        }
        actionAreas.get(trigger).get(owner).add(actionArea);
    }

    @Override
    public void startDrawing() {
        super.startDrawing(); //To change body of generated methods, choose Tools | Templates.
        shutDowner.start();
    }

}
