/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sim.graphics;

import help.math.IntPosition;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.image.BufferedImage;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author Dromliuss
 */
public abstract class ScreenArea implements ScreenNode {

    private final BufferedImage canvas;
    private Graphics2D graphics;
    private final ScreenNode parent;
    private List<ScreenNode> children;
    private final IntPosition position;
    private final String name;
    private final Rectangle absoluteArea;

    public ScreenArea(String name, Rectangle rect, ScreenNode parent) {
        this(name, rect.x, rect.y, rect.width, rect.height, parent);
    }

    public ScreenArea(String name, float relationalX, float relationalY, float witdthOfParent, float heigthOfParent, ScreenNode parent) {
        this(name, (int) (relationalX * parent.getScreenAreaWidth()), (int) (relationalY * parent.getScreenAreaHeight()), (int) (witdthOfParent * parent.getScreenAreaWidth()), (int) (heigthOfParent * parent.getScreenAreaHeight()), parent);
    }

    public ScreenArea(String name, int x, float relationalY, float witdthOfParent, float heigthOfParent, ScreenNode parent) {
        this(name, x, (int) (relationalY * parent.getScreenAreaHeight()), (int) (witdthOfParent * parent.getScreenAreaWidth()), (int) (heigthOfParent * parent.getScreenAreaHeight()), parent);
    }

    public ScreenArea(String name, float relationalX, int y, float witdthOfParent, float heigthOfParent, ScreenNode parent) {
        this(name, (int) (relationalX * parent.getScreenAreaWidth()), y, (int) (witdthOfParent * parent.getScreenAreaWidth()), (int) (heigthOfParent * parent.getScreenAreaHeight()), parent);
    }

    public ScreenArea(String name, float relationalX, float relationalY, int witdth, float heigthOfParent, ScreenNode parent) {
        this(name, (int) (relationalX * parent.getScreenAreaWidth()), (int) (relationalY * parent.getScreenAreaHeight()), witdth, (int) (heigthOfParent * parent.getScreenAreaHeight()), parent);
    }

    public ScreenArea(String name, float relationalX, float relationalY, float witdthOfParent, int heigth, ScreenNode parent) {
        this(name, (int) (relationalX * parent.getScreenAreaWidth()), (int) (relationalY * parent.getScreenAreaHeight()), (int) (witdthOfParent * parent.getScreenAreaWidth()), heigth, parent);
    }

    public ScreenArea(String name, int x, int y, float witdthOfParent, float heigthOfParent, ScreenNode parent) {
        this(name, x, y, (int) (witdthOfParent * parent.getScreenAreaWidth()), (int) (heigthOfParent * parent.getScreenAreaHeight()), parent);
    }

    public ScreenArea(String name, int x, float relationalY, int witdth, float heigthOfParent, ScreenNode parent) {
        this(name, x, (int) (relationalY * parent.getScreenAreaHeight()), witdth, (int) (heigthOfParent * parent.getScreenAreaHeight()), parent);
    }

    public ScreenArea(String name, int x, float relationalY, float witdthOfParent, int heigth, ScreenNode parent) {
        this(name, x, (int) (relationalY * parent.getScreenAreaHeight()), (int) (witdthOfParent * parent.getScreenAreaWidth()), heigth, parent);
    }

    public ScreenArea(String name, float relationalX, int y, int witdth, float heigthOfParent, ScreenNode parent) {
        this(name, (int) (relationalX * parent.getScreenAreaWidth()), y, witdth, (int) (heigthOfParent * parent.getScreenAreaHeight()), parent);
    }

    public ScreenArea(String name, float relationalX, int y, float witdthOfParent, int heigth, ScreenNode parent) {
        this(name, (int) (relationalX * parent.getScreenAreaWidth()), y, (int) (witdthOfParent * parent.getScreenAreaWidth()), heigth, parent);
    }

    public ScreenArea(String name, float relationalX, float relationalY, int witdth, int heigth, ScreenNode parent) {
        this(name, (int) (relationalX * parent.getScreenAreaWidth()), (int) (relationalY * parent.getScreenAreaHeight()), witdth, heigth, parent);
    }

    public ScreenArea(String name, int x, int y, int witdth, float heigthOfParent, ScreenNode parent) {
        this(name, x, y, witdth, (int) (heigthOfParent * parent.getScreenAreaHeight()), parent);
    }

    public ScreenArea(String name, int x, int y, float witdthOfParent, int heigth, ScreenNode parent) {
        this(name, x, y, (int) (witdthOfParent * parent.getScreenAreaWidth()), heigth, parent);
    }

    public ScreenArea(String name, int x, float relationalY, int width, int heigth, ScreenNode parent) {
        this(name, x, (int) (relationalY * parent.getScreenAreaHeight()), width, heigth, parent);
    }

    public ScreenArea(String name, float relationalX, int y, int witdth, int heigth, ScreenNode parent) {
        this(name, (int) (relationalX * parent.getScreenAreaWidth()), y, witdth, heigth, parent);
    }

    public ScreenArea(String name, ScreenAreaOrientation xOrientation, int y, int witdth, int heigth, ScreenNode parent) {
        this(name, xOrientation.getX(), y, witdth, heigth, parent);
    }

    public ScreenArea(String name, ScreenAreaOrientation xOrientation, float relationalY, int witdth, int heigth, ScreenNode parent) {
        this(name, xOrientation.getX(), (int) (relationalY * parent.getScreenAreaHeight()), witdth, heigth, parent);
    }

    public ScreenArea(String name, ScreenAreaOrientation xOrientation, int y, float witdthOfParent, int heigth, ScreenNode parent) {
        this(name, xOrientation.getX(), y, (int) (witdthOfParent * parent.getScreenAreaWidth()), heigth, parent);
    }

    public ScreenArea(String name, ScreenAreaOrientation xOrientation, float relationalY, float witdthOfParent, int heigth, ScreenNode parent) {
        this(name, xOrientation.getX(), (int) (relationalY * parent.getScreenAreaHeight()), (int) (witdthOfParent * parent.getScreenAreaWidth()), heigth, parent);
    }

    public ScreenArea(String name, ScreenAreaOrientation xOrientation, int y, int witdth, float heigthOfParent, ScreenNode parent) {
        this(name, xOrientation.getX(), y, witdth, (int) (heigthOfParent * parent.getScreenAreaHeight()), parent);
    }

    public ScreenArea(String name, ScreenAreaOrientation xOrientation, float relationalY, int witdth, float heigthOfParent, ScreenNode parent) {
        this(name, xOrientation.getX(), (int) (relationalY * parent.getScreenAreaHeight()), witdth, (int) (heigthOfParent * parent.getScreenAreaHeight()), parent);
    }

    public ScreenArea(String name, ScreenAreaOrientation xOrientation, int y, float witdthOfParent, float heigthOfParent, ScreenNode parent) {
        this(name, xOrientation.getX(), y, (int) (witdthOfParent * parent.getScreenAreaWidth()), (int) (heigthOfParent * parent.getScreenAreaHeight()), parent);
    }

    //
    public ScreenArea(String name, ScreenAreaOrientation xOrientation, int y, ScreenAreaOrientation widthOrientation, float heigthOfParent, ScreenNode parent) {
        this(name, xOrientation.getX(), y, widthOrientation.getWidth(), (int) (heigthOfParent * parent.getScreenAreaHeight()), parent);
    }

    public ScreenArea(String name, ScreenAreaOrientation xOrientation, int y, ScreenAreaOrientation widthOrientation, int heigth, ScreenNode parent) {
        this(name, xOrientation.getX(), y, widthOrientation.getWidth(), heigth, parent);
    }

    public ScreenArea(String name, int x, ScreenAreaOrientation yOrientation, float witdthOfParent, ScreenAreaOrientation heigthOrientation, ScreenNode parent) {
        this(name, x, yOrientation.getY(), (int) (witdthOfParent * parent.getScreenAreaWidth()), heigthOrientation.getHeigth(), parent);
    }

    public ScreenArea(String name, int x, ScreenAreaOrientation yOrientation, int witdth, ScreenAreaOrientation heigthOrientation, ScreenNode parent) {
        this(name, x, yOrientation.getY(), witdth, heigthOrientation.getHeigth(), parent);
    }

    public ScreenArea(String name, int x, ScreenAreaOrientation yOrientation, float witdthOfParent, float heigthOfParent, ScreenNode parent) {
        this(name, x, yOrientation.getY(), (int) (witdthOfParent * parent.getScreenAreaWidth()), (int) (heigthOfParent * parent.getScreenAreaHeight()), parent);
    }
    public ScreenArea(String name, int x, ScreenAreaOrientation yOrientation, int witdth, int heigth, ScreenNode parent) {
        this(name, x, yOrientation.getY(),witdth, heigth, parent);
    }
    public ScreenArea(String name, ScreenAreaOrientation xOrientation, ScreenAreaOrientation yOrientation, ScreenAreaOrientation widthOrientation, float heigthOfParent, ScreenNode parent) {
        this(name, xOrientation.getX(), yOrientation.getY(), widthOrientation.getWidth(), (int) (heigthOfParent * parent.getScreenAreaHeight()), parent);
    }

    public ScreenArea(String name, ScreenAreaOrientation xOrientation, ScreenAreaOrientation yOrientation, ScreenAreaOrientation widthOrientation, int heigth, ScreenNode parent) {
        this(name, xOrientation.getX(), yOrientation.getY(), widthOrientation.getWidth(), heigth, parent);
    }

    public ScreenArea(String name, int x, ScreenAreaOrientation yOrientation, double ratio, ScreenAreaOrientation heightOrientation, ScreenNode parent) {
        this(name, x, yOrientation.getY(), (int) (heightOrientation.getHeigth() * ratio), heightOrientation.getHeigth(), parent);
    }

    public ScreenArea(String name, ScreenAreaOrientation xOrientation, ScreenAreaOrientation yOrientation, ScreenAreaOrientation widthOrientation, ScreenAreaOrientation heightOrientation, ScreenNode parent) {
        this(name, xOrientation.getX(), yOrientation.getY(), widthOrientation.getWidth(), heightOrientation.getHeigth(), parent);
    }

    //
    @SuppressWarnings("LeakingThisInConstructor")
    public ScreenArea(String name, int x, int y, int witdth, int heigth, ScreenNode parent) {
        this.position = new IntPosition(x, y);
        this.canvas = new BufferedImage(witdth, heigth, BufferedImage.TYPE_INT_ARGB);
        this.parent = parent;
        this.name = name;
        this.absoluteArea = new Rectangle(getAbsoulteX(), getAbsoulteY(), witdth, heigth);
        children = new ArrayList<>();
        //
        this.parent.addChild(this);
    }

    public Graphics2D getScreenAreaGraphics() {
        if (graphics == null) {
            graphics = canvas.createGraphics();
            //        System.out.println("creating " + name + " Graphics");
        }
        return graphics;
    }

    @Override
    public DrawCondition internalDrawCondition() {
        DrawCondition parentalDrawCondition = parent.internalDrawCondition();
        if (parentalDrawCondition == DrawCondition.HIDE) {
            return DrawCondition.HIDE;
        }
        return drawCondition(parentalDrawCondition);
    }

    public abstract DrawCondition drawCondition(DrawCondition parentalDrawCondition);

    @Override
    public final void draw() {
        DrawCondition drawCondition = internalDrawCondition();
        if (drawCondition == DrawCondition.HIDE) {
            disposeGraphics();
            return;
        }
        getScreenAreaGraphics().setBackground(new Color(255, 255, 255, 0));
        getScreenAreaGraphics().clearRect(0, 0, getScreenAreaWidth(), getScreenAreaHeight());
        try {
            internalDraw();
        } catch (Exception e) {
            System.out.println("Error @ ScreenArea: " + name + "; cause: " + e.getMessage());
            e.printStackTrace();
        }
        for (ScreenNode child : getChildren()) {
            child.draw();
        }
        parent.drawImage(position, canvas);
    }

    @Override
    public int getScreenAreaWidth() {
        return canvas.getWidth();
    }

    @Override
    public int getScreenAreaHeight() {
        return canvas.getHeight();
    }

    public IntPosition getPosition() {
        return position;
    }

    @Override
    public void drawImage(IntPosition position, BufferedImage bufferedImage) {
        getScreenAreaGraphics().drawImage(bufferedImage, position.getX(), position.getY(), null);
    }

    private void disposeGraphics() {
        if (graphics != null) {
            // System.out.println("AWAAAYYYYYAY " + name);
            graphics.dispose();
            graphics = null;
        }
    }

    public ScreenNode getParent() {
        return parent;
    }

    @Override
    public List<ScreenNode> getChildren() {
        return children;
    }

    @Override
    public void addChild(ScreenNode child) {
        children.add(child);
    }

    @Override
    public void addActionArea(Trigger trigger, ScreenNode owner, ScreenActionArea actionArea) {
        actionArea.getArea().translate(getPosition().getX(), getPosition().getY());
        getParent().addActionArea(trigger, owner, actionArea);
    }

    public void addNewActionArea(Trigger trigger, ScreenActionArea actionArea) {
        addActionArea(trigger, this, actionArea);
    }

    public abstract void internalDraw();

    @Override
    public Rectangle getAbsoluteArea() {
        return absoluteArea;
    }

    @Override
    public final int getAbsoulteX() {
        return getPosition().getX() + parent.getAbsoulteX();
    }

    @Override
    public final int getAbsoulteY() {
        return getPosition().getY() + parent.getAbsoulteY();
    }

    @Override
    public String toString() {
        return name+" ("+getParent().getName()+"): "+getScreenAreaWidth()+" X "+getScreenAreaHeight()+" @ ("+getPosition().getX()+" / "+getPosition().getY()+")";
    }

    @Override
    public String getName() {
        return name;
    }
}
