/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sim.graphics;

import help.math.IntPosition;
import java.awt.Rectangle;
import java.awt.image.BufferedImage;
import java.util.List;

/**
 *
 * @author Dromliuss
 */
public interface ScreenNode {

    public DrawCondition internalDrawCondition();

    public void drawImage(IntPosition position, BufferedImage bufferedImage);

    public void draw();

    public void addChild(ScreenNode child);

    public List<ScreenNode> getChildren();

    public int getScreenAreaWidth();

    public int getScreenAreaHeight();

    public int getAbsoulteX();

    public int getAbsoulteY();

    public Rectangle getAbsoluteArea();

    public String getName();

    public void addActionArea(Trigger trigger, ScreenNode owner, ScreenActionArea actionArea);
}
