/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package help.math;

import java.io.Serializable;

/**
 *
 * @author Felix
 */
public class IntPosition implements Serializable{

    private int x;
    private int y;

    public IntPosition(int x, int y) {
        this.x = x;
        this.y = y;
    }

    public IntPosition() {
    }
    

    public int getX() {
        return x;
    }

    public int getY() {
        return y;
    }


    public void setX(int x) {
        this.x = x;
    }

    public void setY(int y) {
        this.y = y;
    }

    public double getDistanceToThis(Position to) {
        return Math.sqrt((to.getX() - getX()) * (to.getX() - getX()) + (to.getY() - getY()) * (to.getY() - getY()));
    }

    public double angleBetween(Position to) {
        return Math.atan2(to.getY() - getY(), to.getX() - getX());
    }

    public void addVector(Vector vector) {
        x += vector.getdX();
        y += vector.getdY();
    }

    public boolean equals(IntPosition pos) {        
        return ((this.x == pos.getX()) && (this.y == pos.getY()));
    }    

    @Override
    public String toString() {
        return "("+getX()+" | "+getY()+")";
    }
    
    public void incX(int inc){
        setX(getX()+inc);
    }
    public void incY(int inc){
        setY(getY()+inc);
    }
    
}
