/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package help.math;

import java.awt.Point;
import java.io.Serializable;

/**
 *
 * @author Felix
 */
public class Position implements Serializable{

    private double x;
    private double y;

    public Position(double x, double y) {
        this.x = x;
        this.y = y;
    }

    public Position(Point point) {
        this.x = point.getX();
        this.y = point.getY();
    }

    public Position(Position position) {
        this.x = position.getX();
        this.y = position.getY();
    }

    public Position(IntPosition position) {
        this.x = position.getX();
        this.y = position.getY();
    }

    public double getX() {
        return x;
    }

    public double getY() {
        return y;
    }

    public int getRoundX() {
        return (int) Math.round(x); // -0.5 : shift UpRight -> Center!!!!
    }

    public int getRoundY() {
        return (int) Math.round(y);
    }

    public void setX(double x) {
        this.x = x;
    }

    public void setY(double y) {
        this.y = y;
    }

    public double getDistanceToThis(Position to) {
        return Math.sqrt((to.getX() - getX()) * (to.getX() - getX()) + (to.getY() - getY()) * (to.getY() - getY()));
    }

    public double angleBetween(Position to) {
        return Math.atan2(to.getY() - getY(), to.getX() - getX());
    }

    public void addVector(Vector vector) {
        setX(getX() + vector.getdX());
        setY(getY() + vector.getdY());
    }

    public void moveTowards(double x, double y, double maxSpeed) {
        if (Math.sqrt((x - getX()) * (x - getX()) + (y - getY()) * (y - getY())) <= maxSpeed) {
            setX(x);
            setY(y);
        } else {
            Vector vector = new Vector(x - getX(), y - getY());
            vector.setLength(maxSpeed);
            addVector(vector);
        }

    }

    @Override
    public boolean equals(Object obj) {
        if (!(obj instanceof Position)) {
            return false;
        }

        return ((this.x == ((Position) obj).getX()) && (this.y == ((Position) obj).getY()));
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 71 * hash + (int) (Double.doubleToLongBits(this.x) ^ (Double.doubleToLongBits(this.x) >>> 32));
        hash = 71 * hash + (int) (Double.doubleToLongBits(this.y) ^ (Double.doubleToLongBits(this.y) >>> 32));
        return hash;
    }
}
