/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sim.network;

import java.rmi.AlreadyBoundException;
import java.rmi.NotBoundException;
import java.rmi.RemoteException;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;
import java.rmi.server.UnicastRemoteObject;
import sim.data.Neighborhood;
import sim.data.World;

/**
 *
 * @author Dromliuss
 */
public class Server {

    private static Registry reg = null;

    public Server(Neighborhood neighborhood) {
        
        try {
            boolean registryUp = false;
            while (!registryUp) {
                try {
                    reg = LocateRegistry.getRegistry();
                    reg.rebind("test", new UnicastRemoteObject() {
                    }); // testing if registry is legit
                    reg.unbind("test");
                    registryUp = true;
                } catch (RemoteException rE) {
                    System.out.println("Creating registry...");
                    LocateRegistry.createRegistry(1099);
                    System.out.println("Created registry!");
                } catch (NotBoundException nBE) {
                    System.err.println("Something went terribly wrong: 698");
                }
            }

            //  serverCore = (ServerCore) serverClass.getConstructors()[0].newInstance(settings);
            reg.bind("Neighborhood",neighborhood );
            reg.bind("World",World.getWorld() );
        } catch (RemoteException rE) {
            System.err.println("AARRRGGG");
            rE.printStackTrace();
            return;
        } catch (AlreadyBoundException abe) {
            System.err.println("Core alreay up!!!");
            return;
        }
        System.out.println(">>>> Server up!");
    }
}
