/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sim.test;

import java.awt.Font;
import java.awt.HeadlessException;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.net.MalformedURLException;
import java.rmi.Naming;
import java.rmi.NotBoundException;
import java.rmi.RemoteException;
import javax.imageio.ImageIO;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JTextField;
import sim.data.HausRemote;
import sim.data.NeighborhoodRemote;
import sim.data.WorldRemote;
import sim.graphics.DoubleBufferedPanel;
import sim.graphics.HausPanel;

/**
 *
 * @author Dromliuss
 */
public class StartClient {

    private static JFrame login;
    private static DoubleBufferedPanel loginPanel;
    
    /**
     * @param args the command line arguments
     * @throws java.lang.Exception
     */
    @SuppressWarnings("SleepWhileInLoop")
    public static void main(String[] args) throws Exception {
        login = new JFrame("LogIn");
        login.setSize(400, 300);
        loginPanel = new DoubleBufferedPanel(500, 400) {
            private BufferedImage mainBg;
            private Font font;
            boolean set = false;

            @Override
            protected void internalDraw() {
                if (!set) {
                    try {
                        font = new Font("Arial", Font.BOLD, 24);
                        mainBg = ImageIO.read(new File("./cache/serverBg.png").toURI().toURL());
                    } catch (IOException ioe) {
                        System.out.println("OMdG?!");
                    }

                    final JTextField name = new JTextField();
                    name.setSize(300, 50);
                    name.setLocation(50, 25);
                    name.setFont(font);
                    add(name);
                    //
                    final JTextField connect = new JTextField();
                    connect.setSize(300, 50);
                    connect.setLocation(50, 125);
                    connect.setFont(font);
                    add(connect);
                    //
                    JButton start = new JButton("Verbinden");
                    start.addActionListener(new ActionListener() {

                        @Override
                        public void actionPerformed(ActionEvent e) {
                            boolean success = true;
                            try {
                                HausRemote haus = ((NeighborhoodRemote) Naming.lookup("//" + connect.getText() + ":1099/Neighborhood")).getHaus(name.getText());
                                JFrame f = new JFrame("SmartCluster");
                                f.setSize(1000, 700);
                                final HausPanel gamePanel = new HausPanel(1000, 700, haus, ((WorldRemote) Naming.lookup("//" + connect.getText() + ":1099/World")));
                                f.add(gamePanel);
                                f.setVisible(true);
                                f.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
                                f.setResizable(false);
                                gamePanel.startDrawing();
                            } catch (HeadlessException | MalformedURLException | NotBoundException | RemoteException ex) {
                                success = false;
                            }
                            if (success) {
                                login.setVisible(false);
                            }
                        }
                    });
                    start.setSize(100,50);
                    start.setLocation(50, 200);
                    add(start);
                    set = true;
                }

            }

        };
        login.add(loginPanel);
        login.setVisible(true);
        login.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        login.setResizable(false);
        loginPanel.startDrawing();
/*
        HausRemote haus = ((NeighborhoodRemote) Naming.lookup("//localhost:1099/Neighborhood")).getHaus("Client" + Math.random());
        JFrame f = new JFrame("SmartCluster");
        f.setSize(1000, 700);
        final HausPanel gamePanel = new HausPanel(1000, 700, haus, ((WorldRemote) Naming.lookup("//localhost:1099/World")));
        f.add(gamePanel);
        f.setVisible(true);
        f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        f.setResizable(false);
        gamePanel.startDrawing();
        //f.setState(Frame.ICONIFIED);*/
    }

}
