/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sim.test;

import java.awt.Color;
import java.awt.Font;
import java.awt.image.BufferedImage;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.rmi.RemoteException;
import javax.imageio.ImageIO;
import javax.swing.JFrame;
import sim.data.Neighborhood;
import sim.data.PowerPlant;
import sim.graphics.DoubleBufferedPanel;
import sim.graphics.PowerplantPanel;
import sim.network.Server;

/**
 *
 * @author Dromliuss
 */
public class StartGameServer {

    private static JFrame f;

    /**
     * @param args the command line arguments
     * @throws java.rmi.RemoteException
     */
    public static void main(String[] args) throws RemoteException {
        Neighborhood neighborhood = new Neighborhood();
        Server s = new Server(neighborhood);
        PowerPlant.createPowerplant(neighborhood);

        Thread powerPlantThread = new Thread(new Runnable() {
            private BufferedImage mainBg;
            private Font font;

            @Override
            @SuppressWarnings("SleepWhileInLoop")
            public void run() {
                long timeStart = System.currentTimeMillis();
                while (System.currentTimeMillis() - timeStart < 180000) {
                    PowerPlant.get().run();
                    try {
                        Thread.sleep(200);
                    } catch (InterruptedException ie) {
                        System.out.println("WTFTF");
                    }
                }
                BufferedWriter bw = null;
                try {
                    File report = new File("smart.txt");
                    bw = new BufferedWriter(new FileWriter(report));
                    for (String s : PowerPlant.get().report) {
                        bw.write(s);
                        bw.newLine();
                    }

                } catch (IOException ioe) {
                    ioe.printStackTrace();
                } finally {
                    try {
                        if (bw != null) {
                            bw.close();
                        }
                    } catch (IOException ioe) {
                        ioe.printStackTrace();
                    }
                }
                PowerPlant.get().stopWatch();
                f.setVisible(false);
                JFrame result = new JFrame("Score");
                result.setSize(600, 200);

                try {
                    font = new Font("Arial", Font.BOLD, 24);
                    mainBg = ImageIO.read(new File("./cache/serverBg.png").toURI().toURL());
                } catch (IOException ioe) {
                    System.out.println("OMG?!");
                }
                final DoubleBufferedPanel gamePanel = new DoubleBufferedPanel(600, 200) {

                    @Override
                    protected void internalDraw() {
                        graphics.setFont(font);
                        graphics.drawImage(mainBg, 0, 0, null);
                        graphics.setColor(Color.YELLOW);
                        graphics.drawString("Überproduziert: " + ((int) (PowerPlant.get().getWasted() * 100)) / 100d + " €", 20, 70);
                        graphics.drawString("Blackout: " + (int) PowerPlant.get().blackouttime + ":" + (int) ((PowerPlant.get().blackouttime - (int) PowerPlant.get().blackouttime) * 60) + " h", 20, 120);
                    }

                };
                result.add(gamePanel);
                result.setVisible(true);
                result.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
                result.setResizable(false);
                gamePanel.startDrawing();
            }
        });

        f = new JFrame("SmartClusterPower");
       f.setSize(825, 900);
        final PowerplantPanel gamePanel = new PowerplantPanel(825, 900, true);
        f.add(gamePanel);
        f.setVisible(true);
        f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        f.setResizable(false);
        gamePanel.startDrawing();

        powerPlantThread.start();
    }

}
