/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sim.test;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.rmi.RemoteException;
import javax.swing.JFrame;
import sim.data.Neighborhood;
import sim.data.PowerPlant;
import sim.graphics.PowerplantPanel;
import sim.network.Server;

/**
 *
 * @author Dromliuss
 */
public class StartServer {

    /**
     * @param args the command line arguments
     * @throws java.rmi.RemoteException
     */
    public static void main(String[] args) throws RemoteException {
        Neighborhood neighborhood = new Neighborhood();
        Server s = new Server(neighborhood);
        //   final PowerPlant powerPlant = new PowerPlant(neighborhood);
        PowerPlant.createPowerplant(neighborhood);

        Thread powerPlantThread = new Thread(new Runnable() {

            @Override
            @SuppressWarnings("SleepWhileInLoop")
            public void run() {
                while (true) {
                    PowerPlant.get().run();
                    try {
                        Thread.sleep(200);
                    } catch (InterruptedException ie) {
                        System.out.println("WTFTF");
                    }
                }
            }
        });

        JFrame f = new JFrame("SmartClusterPower");
        f.setSize(825, 900);
        final PowerplantPanel gamePanel = new PowerplantPanel(825, 900, false);
        f.add(gamePanel);
        f.setVisible(true);
        f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        f.setResizable(false);
        f.addWindowListener(new WindowAdapter() {

            @Override
            public void windowClosing(WindowEvent e) {
             //   System.out.println("YOLOOOOO");
                BufferedWriter bw = null;
                try {
                    File report = new File("smart.txt");
                    bw = new BufferedWriter(new FileWriter(report));
                    for (String s : PowerPlant.get().report) {
                        bw.write(s);
                        bw.newLine();
                    }

                } catch (IOException ioe) {
                    ioe.printStackTrace();
                } finally {
                    try {
                        if (bw != null) {
                            bw.close();
                        }
                    } catch (IOException ioe) {
                        ioe.printStackTrace();
                    }
                }
            }

        });
        gamePanel.startDrawing();

        powerPlantThread.start();
    }

}
